/** "Hello, world." program for HyperCast 2.0
*
* @author Multimedia Networks Group
* @author HyperCast Team 
* @version Hello World (Callback Version) 1.0, Nov 2001
*/


import java.util.*;
import java.io.*;
import java.net.*;
import hypercast.*;
import hypercast.events.*;

public class HelloWorld implements I_ReceiveCallback
{ 

	public void ReceiveCallback(I_OverlayMessage RecvdMessage)
	{
	     /* get the logical address of the sender */ 
	     String SenderSrc = RecvdMessage.getSourceAddress().toString();
	
	     /* Next we transfor the received message into a string */
	     String sMsg=new String(RecvdMessage.getPayload(), 0, 
	     RecvdMessage.getPayloadLength());
	
	     /* ... and print the payload */ 
		 //if(!RecvdMessage.getSrcLogicalAddress().equals(MySocket.getLogicalAddress()))
		 System.out.println("Received <"+ sMsg + ">from node with logical address: " +SenderSrc +" . ");
	}


	public static void main(String[] args)
	{
	
		HelloWorld hw = new HelloWorld();
	
		NotificationHandler cnh = new myNotificationHandler ();
	
		String MyString = new String("Hello World");
	
		HyperCastConfig ConfObj = HyperCastConfig.createConfig("hypercast.xml");
	
		I_OverlaySocket MySocket=ConfObj.createOverlaySocket ((I_ReceiveCallback) hw, cnh);
	
		MySocket.joinOverlay();
	
		/*
		 * Application blocks here until event NODE_ISSTABLE occurs.
		 */
		cnh.waitUntil_NODE_ISSTABLE();
	
		System.out.println("This node's logical address is:" +MySocket.getLogicalAddress().toString());

		/*
		 * Send message to other applications.
		 */	
	    I_OverlayMessage MyMessage = MySocket.createMessage(MyString.getBytes());
	
	    MySocket.sendToAll(MyMessage);
	
	}

}

class myNotificationHandler extends NotificationHandler
{
	public void handle_NODE_ISSTABLE(NODE_ISSTABLE event)
	{
			System.out.println("event NODE_ISSTABLE has occured!");
	}
		
	public void handle_NODE_NEIGHBORHOODCHANGED(NODE_NEIGHBORHOODCHANGED event)
	{
		System.out.println("event NODE_NEIGHBORHOODCHANGED has occured!");
	}
}
